<template>
  <div class="i">
    <table class="table table-dark table-striped">
      <thead>
        <tr class="text-center">
          <th>Foto</th>
          <th>Nome</th>
          <th>Email</th>
          <th>Data De Inscrição</th>
          <th>Tornar Moderador</th>
          <th>Deletar</th>
        </tr>
      </thead>
      <tbody v-for="dados in UserDados" :key="dados.idU">
        <tr class="text-center">
          <td>
            <img class="img-circle img-sm" alt="User img " :src="dados.foto" />
          </td>
          <td class="td">{{ dados.nome }}</td>
          <td>{{ dados.email }}</td>
          <td>{{ dados.created_at }}</td>
          <td>
            <b-button
              class="btn btn-info"
              @click="HandlerModerador(dados.idU)"
              data-toggle="modal"
              data-target="#modalModerador"
              ><b-icon icon="tools"></b-icon
            ></b-button>
          </td>
          <td>
            <b-button
              @click="HandlerExcluir(dados.idU)"
              data-toggle="modal"
              data-target="#modalDeletar"
              class="btn btn-danger"
              ><b-icon icon="trash-fill"></b-icon
            ></b-button>
          </td>
        </tr>
      </tbody>
    </table>

    <!-- Modal Excluir -->
    <div>
      <!-- The Modal -->
      <div class="modal fade" id="modalDeletar" role="dialog">
        <div class="modal-dialog">
          <div class="modal-content">
            <!-- Modal Header -->
            <div id="addcoment" class="modal-header">
              <h3>Deseja Deletar o Usuario(a)?</h3>
            </div>

            <!-- Modal footer -->
            <div class="modal-footer" id="bottonDeletar">
              <button
                type="button"
                class="btn-dark btn-sm mr-2"
                data-dismiss="modal"
              >
                <b-icon
                  icon="x"
                  scale="2"
                  variant="white"
                  class="mr-2"
                ></b-icon>
                Cancelar
              </button>
              <button
                @click.prevent="DeletarUsuario"
                class="btn btn-sm btn-danger"
                type="submit"
                data-dismiss="modal"
              >
                <b-icon icon="trash-fill" font-scale="1"></b-icon> Deletar
              </button>
            </div>
          </div>
        </div>
      </div>
    </div>
    <!--  -->

    <!-- Modal Moderador -->
    <div>
      <!-- The Modal -->
      <div class="modal fade" id="modalModerador" role="dialog">
        <div class="modal-dialog">
          <div class="modal-content">
            <!-- Modal Header -->
            <div id="addcoment" class="modal-header">
              <h3>Tornar este Usuario(a) Moderador?</h3>
            </div>

            <!-- Modal footer -->
            <div class="modal-footer" id="bottonDeletar">
              <button
                type="button"
                class="btn-dark btn-sm mr-2"
                data-dismiss="modal"
              >
                <b-icon
                  icon="x"
                  scale="2"
                  variant="white"
                  class="mr-2"
                ></b-icon>
                Cancelar
              </button>
              <button
                @click.prevent="TornarModerador"
                class="btn btn-sm btn-success"
                type="submit"
                data-dismiss="modal"
              >
                <b-icon icon="check" scale="2" variant="white"></b-icon>
                Confirmar
              </button>
            </div>
          </div>
        </div>
      </div>
    </div>
    <!--  -->
  </div>
</template>

<script>
import axios from "axios";

export default {
  data() {
    return {
      UserDados: [],
    };
  },

  methods: {
    HandlerExcluir(valor) {
      this.deleteUser = valor;
    },
    HandlerModerador(valor) {
      this.ModerUser = valor;
      console.log(`${this.$urlAPI}/userAdm/${this.ModerUser}`)
    },
    DeletarUsuario() {
      if (localStorage.getItem("token")) {
        axios
          .delete(`${this.$urlAPI}/user/${this.deleteUser}`, {
            headers: {
              Authorization: `Bearer ${localStorage.getItem("token")}`,
            },
          })
          .then((response) => {
            if (response.data.erro == "true") {
              alert(response.data.msg);
            } else {
              alert(response.data.msg);
            }
          });
        window.location.reload();
      }
    },
    TornarModerador() {
      if (localStorage.getItem("token")) {
        axios
          .put(`${this.$urlAPI}/userAdm/${this.ModerUser}`,{
            headers: {
              Authorization: `Bearer ${localStorage.getItem("token")}`,
            },
          })
          .then((response) => {
            if (response.data.erro == "false") {
              alert(response.data.msg)
            }
            if (response.data.erro == "true") {
              alert(response.data.msg);
            }
          });
         window.location.reload(); 
      }
    },
  },
  
  mounted() {
    if (localStorage.getItem("token")) {
      axios
        .get(this.$urlAPI + "/users", {
          headers: {
            Authorization: `Bearer ${localStorage.getItem("token")}`,
          },
        })
        .then((response) => {
          if (response.data.erro == "false") {
            this.UserDados = response.data.msg;
          }
          if (response.data.erro == "true") {
            alert(response.data.msg);
          }
        });
    } else {
      this.$router.push("/login").catch(() => {});
    }
  },
};
</script>

<style scoped>
.td {
  margin-top: 15px;
}

#bottonDeletar {
  align-self: center;
}
</style>